Whamcloud - gitweb
LU-7144 tests: skip scrub/lfsck test under interoperation
[fs/lustre-release.git] / contrib / lbuild / lbuild
1 #!/bin/bash
2
3 # vim:expandtab:shiftwidth=4:softtabstop=4:tabstop=4:
4
5 # this is an alternative FD for stdout, to be used especially when we are
6 # taking stdout from a function as it's return value.  i.e. foo=$(bar)
7 # this is a workaround until a version of bash where we can put xtrace
8 # on a specific FD
9 exec 3>&1; STDOUT=3
10
11 #set -x
12 xtrace="+x"
13 if [[ $SHELLOPTS = *xtrace* ]]; then
14     xtrace="-x"
15 fi
16 shopt -s extdebug
17
18 # Assume that lbuild's support files can be found in the same
19 # canonicalized path as this very script.
20 LBUILD_SCRIPT=$(readlink -f ${0})
21 LBUILD_DIR=${LBUILD_DIR:-$(dirname ${LBUILD_SCRIPT})}
22
23 # include the exit_traps library
24 . ${LBUILD_DIR}/exit_traps.sh
25 . ${LBUILD_DIR}/funcs.sh
26
27 # our children should die when we do
28 push_exit_trap "kill -INT -$$ || true" kill_children
29
30 # increment this if you have made a change that should force a new kernel
31 # to build built
32 #BUILD_GEN=1
33 #BUILD_GEN=2    # bz19952: remove -lustre tag from kernel RPM names
34 #BUILD_GEN=3    # bz19975: enable the building of src.rpms by default
35 #BUILD_GEN=4    # bz22281: use the git hash in the kernel extra version
36 #BUILD_GEN=5    # TT-107: don't cache the BUILD dir
37 BUILD_GEN=6     # TT-1092: don't cache the BUILD dir, to rebuild external OFED
38
39 TOPDIR=$PWD
40
41 KERNELDIR=
42 LINUX=
43 LUSTRE=
44 RELEASE=false
45 # XXX - some recent hacking has pretty much neutered this option.
46 #       search through this file for "-bb" and see how many places
47 #       simply don't account for this option
48 DO_SRC=true
49 DOWNLOAD=true
50 CANONICAL_TARGET=
51 TARGET=
52 TARGET_ARCH="$(uname -m)"
53 # change default behavior to only build for the current arch
54 TARGET_ARCHS="$TARGET_ARCH"
55 TARGET_ARCHS_ALL="$TARGET_ARCH"
56 [ "$TARGET_ARCH" = "i686" ] && TARGET_ARCHS_ALL="i686 i586 i386"
57 CONFIGURE_FLAGS=
58 EXTERNAL_PATCHES=
59 EXTRA_VERSION=
60 STAGEDIR=
61 TMPDIR=${TMPDIR:-"/var/tmp"}
62 TIMESTAMP=
63 # this is the dir that should be used to store reuse products
64 REUSEBUILD=
65 # should cached products be used or force rebuilding?
66 USE_BUILD_CACHE=true
67 # what does this do exactly?  does it imply no kernel build?
68 NORPM=false
69 IOKITRPM=true
70 OSDLDISKFSRPM=true
71 OSDZFSRPM=false
72 SMPTYPES="smp bigsmp default ''"
73 PATCHLESS=false
74 WITH_ZFS=""
75 XEN=false
76 LINUXOBJ=
77 DISTRO=
78 KERNELTREE=
79 # default to not adding -lustre- into the kernel RPM package names
80 KERNEL_LUSTRE_NAMING=false
81 # default not use kabi check.
82 USE_KABI=false
83
84 # patchless build
85 KERNELRPMSBASE=
86 RPMSMPTYPE=
87
88 # from target file
89 SERIES=
90 BASE_ARCHS=
91 BIGMEM_ARCHS=
92 BOOT_ARCHS=
93 JENSEN_ARCHS=
94 SMP_ARCHS=
95 BIGSMP_ARCHS=
96 PSERIES64_ARCHS=
97 UP_ARCHS=
98
99 # not in the target file any more
100 CONFIG=
101
102 # build the lustre-tests rpm?
103 LUSTRE_TESTS=true
104
105 DATE=$(date)
106
107 RPMBUILD=
108
109 export CC=${CC:-gcc}
110
111 # Readlink is not present on some older distributions: emulate it.
112 readlink() {
113     local path=$1 ll
114
115     if [ -L "$path" ]; then
116         ll="$(LC_ALL=C ls -l "$path" 2> /dev/null)" &&
117         echo "${ll/* -> }"
118     else
119         return 1
120     fi
121 }
122
123 usage() {
124     cat <<EOF
125 Usage: ${0##*/} [OPTION]... [-- <lustre configure options>]
126
127   --external-patches=EXTERNAL_PATCHES
128     Directory similar to lustre/lustre/kernel_patches/ that lbuild should
129     look for seres and config files in before looking in the lustre
130     tree.
131
132   --extraversion=EXTRAVERSION
133     Text to use for the rpm release and kernel extraversion.
134
135   --timestamp=TIMESTAMP
136     Date of building lustre in format YYYYMMDDhhmmss
137
138   --reusebuild=DIR
139     Try to reuse old kernel builds from DIR
140
141   --kernelrpm=DIR
142     Path to distro kernel RPM collection
143
144   --ccache
145     Use ccache
146
147   --norpm
148     Do not build RPMs (compile only mode)
149
150   --patchless
151     Build lustre client only
152
153   --distro=DISTRO
154     Which distro using. Autodetect by default
155
156   --kerneldir=KERNELDIR
157     Directory containing Linux source tarballs referenced by target
158     files.
159
160   --kerneltree=KERNELTREE
161     Directory containing dirs with Linux source tarballs referenced by target
162     files. Dir names in format kernel version ('2.6.9', etc.)
163
164   --linux=LINUX --with-linux=LINUX
165     Directory of Linux kernel sources.  When this option is used, only
166     Lustre modules and userspace are built.
167
168   --lustre=LUSTRE
169     Path to an existing lustre source tarball to use.
170
171   --nodownload
172     Do not try to download a kernel from downloads.hpdd.intel.com
173
174   --nosrc
175     Do not build a .src.rpm, a full kernel patch, or a patched kernel
176     tarball.
177
178   --ldiskfs
179     Build with ldiskfs support. (Deprecated, always true)
180
181   --noiokit
182     Do not build lustre-iokit RPM. Now true by default
183
184   --publish
185     Unused.
186
187   --release
188     Specifies that the files generated do not include timestamps, and
189     that this is an official release.
190
191   --disable-zfs
192     Build Lustre without ZFS.
193
194   --src
195     Build a .src.rpm, a full kernel patch, and a patched kernel tarball.
196
197   --stage=DIR
198     Directory used to stage packages for release.  RPMs will be placed
199     more or less in DIR/<target>-<arch>, and the tarball will be
200     placed in DIR.
201
202   --target=TARGET
203     The name of the target to build.  The available targets are listed
204     below.
205
206   --target-archs=TARGET_ARCHS
207     A (space delimited) list of architectures to build.  By default,
208     all of the archs supported by the TARGET will be built, in
209     addition to a .src.rpm.  This option can limit those, for machines
210     that can only build certain archs or if you only want a certain
211     arch built (for testing, or a one-off kernel).
212
213     Also note that by using a non-"base" arch (eg, i386) only kernels
214     will be built - there will be no lustre-lite-utils package.
215
216   --xen
217     Builds a Xen domX kernel.
218
219   --set-value
220     Sets a variable to a given value.
221
222 EOF
223
224 #   list_targets
225
226     fatal "$1" "$2"
227 }
228
229 # canonicalize a relative path to a file
230 canon_filepath() {
231     local PATH="$1"
232
233     if [ ! -f "$PATH" ]; then
234         return 1
235     fi
236
237     local FILE=${PATH##*/}
238     local DIR=${PATH%/*}
239
240     echo $(canon_path "$DIR")/$FILE
241     return 0
242 }
243
244 # canonicalize a relative path to a dir
245 canon_path() {
246     local PATH="$1"
247
248     if [ ! -d "$PATH" ]; then
249         return 1
250     fi
251
252     pushd "$PATH" >/dev/null || return 1
253     local CANONPATH=$PWD
254     popd >/dev/null
255
256     echo "$CANONPATH"
257     return 0
258 }
259
260 check_options() {
261
262     if [ -z "$LUSTRE" -o ! -r "$LUSTRE" ]; then
263         usage 1 "Could not find Lustre source tarball '$LUSTRE'."
264     fi
265
266     if [ -z "$DISTRO" ] ; then
267         DISTRO=$(autodetect_distro)
268         # remove separator
269         DISTRO=${DISTRO/-/}
270     fi
271     DISTROMAJ=${DISTRO%%.*}
272
273     [ -z "$TARGET" ] && TARGET=$(autodetect_target "$DISTRO")
274
275     if [ -z "$LINUX" ]; then
276         [ "$KERNELDIR" -o "$KERNELTREE" ] || \
277             usage 1 "A kernel directory must be specified with --kerneldir or --kerneltree."
278
279         [ -d "$KERNELDIR" -o -d "$KERNELTREE" ] || \
280             usage 1 "$KERNELDIR and $KERNELTREE are not a directory."
281
282 #       TARGET_FILE="$TOPDIR/lustre/kernel_patches/targets/$TARGET.target"
283 #       [ -r "$TARGET_FILE" ] || \
284 #               usage 1 "Target '$TARGET' was not found."
285     fi
286
287     case $TARGET in
288         3.12-sles12)
289             CANONICAL_TARGET="sles12"
290             ;;
291         3.10-rhel7)
292             CANONICAL_TARGET="rhel7"
293             ;;
294         2.6-rhel6*)
295             CANONICAL_TARGET="rhel6"
296             ;;
297         2.6-rhel5)
298             CANONICAL_TARGET="rhel5"
299             ;;
300         2.6-rhel4)
301             CANONICAL_TARGET="rhel-2.6"
302             ;;
303         2.6-suse)
304             CANONICAL_TARGET="sles-2.6"
305             ;;
306         2.6-sles10)
307             CANONICAL_TARGET="sles10-2.6"
308             ;;
309         2.6-sles11 | 3.0-sles11)
310             CANONICAL_TARGET="sles11"
311             ;;
312         2.6-oel5)
313             CANONICAL_TARGET="oel5"
314             ;;
315         hp_pnnl-2.4)
316             CANONICAL_TARGET="hp-pnnl-2.4"
317             ;;
318         2.6-vanilla \
319             | suse-2.4.21-2 \
320             | rh-2.4 \
321             | rhel-2.4 \
322             | sles-2.4 \
323             | 2.6-patchless)
324                 CANONICAL_TARGET="$TARGET"
325                 ;;
326     esac
327
328     local timestampnodig=$(echo $TIMESTAMP | sed -e s/[0-9]*//g)
329     [ "$timestampnodig" = "" ] || TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
330     local timestamplength="${#TIMESTAMP}"
331     if [ $timestamplength -eq 12 ]; then
332         TIMESTAMP="${TIMESTAMP}00"
333     elif [ $timestamplength -ne 14 ]; then
334         TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
335     fi
336
337     RPMBUILD=$(which rpmbuild 2>/dev/null | head -1)
338     if [ ! "$RPMBUILD" -o "$RPMBUILD" == "" ]; then
339         RPMBUILD=$(which rpm 2>/dev/null | head -1)
340         if [ ! "$RPMBUILD" -o "$RPMBUILD" == "" ]; then
341             usage 1 "Could not find binary for making rpms (tried rpmbuild and rpm)."
342         fi
343     fi
344
345     if [ -n "$CCACHE" ]; then
346         which "$DISTCC" &>/dev/null && export DISTCC RPM_BUILD_NCPUS
347
348         if which "$CCACHE" &>/dev/null; then
349             local ccache=$(which "$CCACHE")
350             local bindir="$TOPDIR/bin"
351
352             if [ ! -d $bindir ]; then
353                 mkdir -p $bindir || fatal 1 "error trying to create $bindir"
354             else
355                 rm ${bindir}/* > /dev/null 2>&1 || true
356             fi
357             ln -s "$ccache" ${bindir}/ccache
358             ln -s "$ccache" ${bindir}/cc
359             ln -s "$ccache" ${bindir}/$CC
360             export PATH=$bindir:$PATH
361             export CCACHE && export CC="ccache $CC"
362             # zero the cache so we can see how effective we are being with it
363             echo -n "ccache "
364             ccache -z
365
366             # get some ccache stats when we are done
367             push_exit_trap '[ -n "$CCACHE" ] && ccache -s' "ccache_summary"
368             # should remove the ccache trap if lbuild is interrupted
369             trap 'echo "Received an INT TERM or HUP signal, terminating."; delete_exit_trap "ccache_summary"; exit 1' INT TERM HUP
370         fi
371     fi
372
373     return 0
374
375 }
376
377 # compare two versions $1 and $2. if $1 < $2, return 0 otherwise return 1.
378 compare_version () {
379     [[ $1 == $2 ]] && return 1
380     local IFS=.
381     local i val1=($1) val2=($2)
382
383     # padding zero to val1 if it needs
384     for ((i=${#val1[@]}; i<${#val2[@]}; i++)); do
385         val1[i]=0
386     done
387     for ((i=0; i<${#val1[@]}; i++)); do
388         [[ -z ${val2[i]} ]] && return 1
389
390         if [[ ${val1[i]} < ${val2[i]} ]]; then
391             return 0
392         elif [[ ${val1[i]} > ${val2[i]} ]]; then
393             return 1
394         fi
395     done
396 }
397
398 uniqify() {
399
400     echo $(echo "$*" | xargs -n 1 | sort -u)
401
402 }
403
404 fetch_url() {
405     local url="$1"
406     local target="$2"
407
408     if [ -z "$target" ]; then
409         fatal 1 "fetch_url() called without a target to fetch to"
410     fi
411
412     if [ -d $target ]; then
413         target+="/${url##*/}"
414     fi
415
416     local rc=0
417     if which wget >/dev/null 2>&1; then
418         if ! wget -nv "$url" -O "$target"; then
419             rc=${PIPESTATUS[0]}
420         fi
421     elif which curl >/dev/null 2>&1; then
422         if ! curl -n -L -s -o "$target" "$url"; then
423             rc=${PIPESTATUS[0]}
424         fi
425     else
426         fatal 1 "Could not find either wget or curl to fetch URLs."
427     fi
428
429     return $rc
430
431 }
432
433 download_srpm() {
434     local target=$1
435     local srpm=$2
436     local force="${3:-false}"
437
438     if $force || [ ! -r "$KERNELDIR/$srpm" ] ||
439        [ ! -s "$KERNELDIR/$srpm" ]; then
440         if $DOWNLOAD; then
441             local location="https://downloads.hpdd.intel.com/public/kernels/$target/old"
442             # get the location from a distro specific method if it exists
443             if type -p kernel_srpm_location; then
444                 location=$(kernel_srpm_location)
445             fi
446             echo "Downloading $location/$srpm..."
447             if ! fetch_url "$location/$srpm" "$KERNELDIR/$srpm" 2>&1 ||
448                [ ! -s "$KERNELDIR/$srpm" ]; then
449                 rm -f $KERNELDIR/$srpm
450                 # punt to a distro specific method if it exists
451                 if ! type -p download_srpm-$DISTROMAJ; then
452                     fatal 1 "Could not download target $target's kernel SRPM $srpm from $location."
453                 else
454                     if ! download_srpm-$DISTROMAJ "$target" "$srpm" "$force"; then
455                         fatal 1 "Could not download target $target's kernel SRPM $srpm using download_srpm-$DISTROMAJ."
456                     fi
457                 fi
458             fi
459         else
460             fatal 1 "$srpm not found in directory $KERNELDIR."
461         fi
462     fi
463
464 }
465
466 download_file() {
467     local from="$1"
468     local to="$2"
469     local force="$3"
470
471     local file=${from##*/}
472
473     if [ -d $to ]; then
474         to="$to/$file"
475     fi
476
477     local semaphore="$to-downloading"
478
479     is_downloading() {
480         if [ ! -f $semaphore ]; then
481             return 1
482         fi
483
484         # make sure the download has not been aborted
485         local now=$(date +%s)
486         local file_mtime=$(stat -c %Y "$to")
487         local staleness=$((now - file_mtime))
488         # let's assume an active download will write at least once a minute
489         if [ $staleness -gt 60 ]; then
490             return 1
491         fi
492
493         return 0
494     }
495
496     is_downloaded() {
497         # if the semaphore file exists, the file is either still downloading
498         # or a download was aborted and we cannot trust the target file
499         if [ -f $semaphore ]; then
500             return 1
501         fi
502
503         if ! is_downloading && [ -r "$to" ] && [ -s "$to" ]; then
504             return 0
505         fi
506
507         return 1
508     }
509
510     if $force || ! is_downloaded; then
511         if is_downloading; then
512             echo "Somebody else is downloading $from..."
513             while is_downloading; do
514                 echo "Waiting for $to to finish downloading"
515                 sleep 60
516             done
517             if is_downloaded; then
518                 return 0
519             else
520                 echo "The download we were waiting for seems to have been aborted"
521             fi
522
523         fi
524
525         if $DOWNLOAD; then
526             echo "Downloading $from..."
527             # flag others so they don't try to download also
528             push_exit_trap "rm -f $to $semaphore" "download"
529             touch $semaphore
530             if ! fetch_url "$from" "$to" || [ ! -s "$to" ]; then
531                 # the trap will remove the files via the fatal below
532                 fatal 1 "Could not download ${to##*/} from ${from%/*}/."
533             fi
534             rm -f $semaphore
535             delete_exit_trap "download"
536         else
537             fatal 1 "${to##*/} not found in directory ${to%/*}."
538         fi
539     fi
540
541     return 0
542
543 }
544
545 download_ofed() {
546     local force="${1:-false}"
547
548     if [ -z "$OFED_VERSION" -o "$OFED_VERSION" = "inkernel" ]; then
549         return 0
550     fi
551
552     local OFED_BASE_VERSION=$OFED_VERSION
553     if [[ $OFED_VERSION = *.*.*.* ]]; then
554         OFED_BASE_VERSION=${OFED_VERSION%.*}
555     fi
556
557     local location="https://www.openfabrics.org/downloads/OFED/ofed-${OFED_BASE_VERSION}/"
558
559     if [[ $OFED_VERSION = *-[rR][cC][0-9] ]]; then
560         local Mmv
561         Mmv=${OFED_VERSION%%-[rR][cC][0-9]}
562         location="https://www.openfabrics.org/downloads/OFED/ofed-${Mmv}/"
563     fi
564
565     if [[ $OFED_VERSION = daily-* ]]; then
566         local Mmv
567         Mmv=${OFED_VERSION/daily-/}
568         daily=${OFED_VERSION##$Mmv-}
569         location="https://www.openfabrics.org/downloads/OFED/ofed-${Mmv}-daily/"
570         # find the filename for the version for the date specified
571         OFED_VERSION=$(curl -s "$location" | sed -nre "/${Mmv}-/s/.*href=\"OFED-(${Mmv}-[0-9]{8,8}-[0-9]{4,4}).tgz.*$/\1/p" | tail -1)
572         if [ -z "$OFED_VERSION" ]; then
573             fatal 1 "Could not determine the filename of the OFED snapshot for ${daily}"
574         fi
575     fi
576
577     local file="OFED-${OFED_VERSION}.tgz"
578     download_file "$location/$file" "$KERNELTREE" "$force"
579
580 }
581
582 parse_mpss_info() {
583     local file="$1"
584     local build="$2"
585     local distro="$3"
586
587     [ -r "$file" ] || fatal 1 "Could not find MPSS info file"
588
589     # convert to MPSS distro naming
590     distro=${distro/sles/suse}
591     distro_name=${distro%%-*}
592
593     # extract links from MPSS info file
594     local urls=$(cat "$file" | \
595         tr -d '\t\r\n' | sed -e 's?\(</[a-zA-Z]*>\)?\1\n?g' | \
596         grep '.intel.com/' | \
597         sed -e 's/^.*[hH][rR][eE][fF]="\([^>"]\+\)".*$/\1/g' | \
598         grep '.tar')
599     local res2=""
600     local res3=""
601     for url in $urls; do
602         local ver2=""
603         local ver3=""
604         # Try to match with MPSS 3.3 package
605         if [[ $url =~ mpss-[0-9].[0-9](.[0-9]*)?-linux.tar ]]; then
606             ver3=${url##*mpss-}
607             ver3=${ver3%%-linux.tar}
608         # Try to match with MPSS 3.x or 3.x.x distro package
609         elif [[ $url =~ mpss-[0-9].[0-9](.[0-9]*)?-$distro.tar ]]; then
610             ver3=${url##*mpss-}
611             ver3=${ver3%%-$distro.tar}
612         # Try to match with MPSS 3.x or 3.x.x source package
613         elif [[ $url =~ mpss-src-[0-9].[0-9](.[0-9]*)?.tar ]]; then
614             ver3=${url##*mpss-src-}
615             ver3=${ver3%%.tar}
616         # Try to match with MPSS 3.x or 3.x.x cross compiler package
617         elif [[ $url =~ mpss-[0-9].[0-9](.[0-9]*)?-k1om.tar ]]; then
618             ver3=${url##*mpss-}
619             ver3=${ver3%%-k1om.tar}
620         # Try to match with MPSS 2.1.x source package
621         elif [[ $url =~ _src-[0-9].[0-9].[0-9]*-[0-9]*_$distro_name.tar ]]; then
622             ver2=${url##*_src-}
623             ver2=${ver2%%_$distro_name.tar}
624         fi
625
626         if [ -n "$ver3" ]; then
627             ver3="${ver3}-0"
628             if [ -z "$build" ]; then
629                 res3="$ver3"
630             elif [ "${build%%-*}" = "${ver3%%-*}" ]; then
631                 res3="$res3 $url"
632             fi
633         elif [ -n "$ver2" ]; then
634             if [ -z "$build" ]; then
635                 res2="$ver2"
636             elif [ "$build" = "$ver2" ]; then
637                 res2="$res2 $url"
638             fi
639         fi
640
641     done
642
643     if [ -z "$build" ]; then
644         # return a last version of MPSS
645         if [ -n "$res3" ]; then
646             echo "$res3"
647         else
648             echo "$res2"
649         fi
650     elif [ "${build%%.*}" = "3" ]; then
651         # return URLs from MPSS info file
652         echo "$res3"
653     else
654         # return URLs from MPSS info file
655         echo "$res2"
656     fi
657 }
658
659 # Get public information about last releases of
660 # Intel Manycore Platform Software Stack (MPSS)
661 download_mpss_info() {
662     local file="$1"
663     local force="${2:-true}"
664     local url=${MPSS_URL:-"http://software.intel.com/en-us/articles/intel-manycore-platform-software-stack-mpss"}
665
666     download_file "$url" "$file" "$force"
667 }
668
669 download_mpss() {
670     local file="$1"
671     local force="${2:-false}"
672     local urls=$(parse_mpss_info "$file" ${MPSS_VERSION} ${MPSS_DISTRO})
673
674     [ -z "$urls" ] && return 0
675
676     local url
677     local i=0
678     for url in $urls; do
679         file="$KERNELTREE/mpss_src-${MPSS_VER}-${MPSS_BLD}-${MPSS_DISTRO}-part$i.tar"
680         download_file "$url" "$file" "$force"
681         i=$((i+1))
682     done
683 }
684
685 load_target() {
686
687     EXTRA_VERSION_save="$EXTRA_VERSION"
688     for patchesdir in "$EXTERNAL_PATCHES" \
689                       "$TOPDIR/lustre/lustre/kernel_patches"; do
690         TARGET_FILE="$patchesdir/targets/$TARGET.target"
691         [ -r "$TARGET_FILE" ] && break
692     done
693     [ -r "$TARGET_FILE" ] || fatal 1 "Target $TARGET was not found."
694
695     echo "Loading target config file $TARGET.target..."
696
697     # if the caller specified an OFED_VERSION it should override whatever
698     # the target file specifies
699     local env_OFED_VERSION="$OFED_VERSION"
700
701     . "$TARGET_FILE"
702
703     if [ -n "$env_OFED_VERSION" ]; then
704         OFED_VERSION="$env_OFED_VERSION"
705     fi
706
707     # doesn't make any sense to build OFED for xen domX's
708     if $XEN; then
709         OFED_VERSION=""
710     fi
711
712     # XXX - set_rpm_smp_type is an ugly undeterministic hack.  it needs to
713     #       go away and the target just specify the $RPMSMPTYPE
714     [ -z "$RPMSMPTYPE" ] && set_rpm_smp_type
715
716     # CC might have been overwritten in TARGET_FILE
717     if [[ $CC != ccache\ * ]] && which "$CCACHE" &>/dev/null; then
718         export CCACHE && export CC="ccache $CC"
719     fi
720
721     if [ ! "$KERNELTREE" = "" ] && [ -d "$KERNELTREE" ]; then
722         KERNELDIR="$KERNELTREE/${lnxmaj}"
723         [ -d "$KERNELDIR" ] || mkdir "$KERNELDIR"
724     fi
725
726     # verify the series is available
727     if [ "$SERIES" ]; then
728         for series in $SERIES; do
729             for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
730                 [ -r "$patchesdir/series/$series" ] && continue 2
731             done
732             fatal 1 "Target $TARGET's series $SERIES could not be found.\nSearched:\n\t$EXTERNAL_PATCHES/series\n\t$TOPDIR/lustre/lustre/kernel_patches/series."
733         done
734     fi
735
736     # set the location of the .config file
737     local XENPOSTFIX=""
738     if $XEN; then
739         XENPOSTFIX="-xen"
740     fi
741
742     if [ -f $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET-$TARGET_ARCH.config ]; then
743         CONFIG_FILE="$TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET$XENPOSTFIX-$TARGET_ARCH.config"
744     fi
745
746     local lnxrelnew=${lnxrel//-/_}
747
748     # remember the EXTRA_VERSION before we diddle it here
749     # XXX - we really should not diddle with any values read in from the
750     #       target file.  if we want to modify a value, we should create
751     #       a new variable.
752     PRISTINE_EXTRA_VERSION=$EXTRA_VERSION
753
754     if ! $PATCHLESS && [ ! -f "$CONFIG_FILE" ]; then
755         fatal 1 "Config file for target $TARGET missing from $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/."
756     fi
757
758     if [ "$EXTRA_VERSION_save" ]; then
759         EXTRA_VERSION="$EXTRA_VERSION_save"
760     elif ! $RELEASE; then
761         # if there is no patch series, then this is not a lustre specific
762         # kernel.  don't make it look like one
763         if $PATCHLESS || [ -n "$SERIES" ]; then
764             EXTRA_VERSION=$(echo $EXTRA_VERSION | sed -e "s/\(.*_lustre\)\..*/\1/")
765             if ! $PATCHLESS && [ -n "$BUILDID" ]; then
766                 EXTRA_VERSION="${EXTRA_VERSION}.${BUILDID}"
767             fi
768         fi
769     fi
770     # EXTRA_VERSION=${EXTRA_VERSION//-/_}
771
772     ALL_ARCHS="$BASE_ARCHS $BIGMEM_ARCHS $BOOT_ARCHS $JENSEN_ARCHS $SMP_ARCHS $BIGSMP_ARCHS $PSERIES64_ARCHS $UP_ARCHS"
773
774     BUILD_ARCHS=
775     for arch in $(uniqify "$ALL_ARCHS"); do
776         if [ -z "$TARGET_ARCHS" ] ||
777            [[ \ $TARGET_ARCHS\  = *\ $arch\ * ]]; then
778             BUILD_ARCHS="$BUILD_ARCHS $arch"
779         fi
780     done
781     [ "$BUILD_ARCHS" ] || usage 1 "No available target archs to build."
782     echo "Building for: $BUILD_ARCHS"
783 }
784
785 tarflags() {
786     local file="$1"
787
788     echo -n '--wildcards '
789     case "$file" in
790         '')
791             fatal 1 "tarflags(): File name argument missing."
792             ;;
793         *.tar.gz | *.tgz)
794             echo '-zxf'
795             ;;
796         *.tar.bz2)
797             echo '-jxf'
798             ;;
799         *.tar)
800             echo '-xf'
801             ;;
802         *)
803             fatal 1 "tarflags(): Unrecognized tar extension in file: $1"
804             ;;
805     esac
806
807 }
808
809 untar() {
810     local tarfile="$1"
811     shift
812     local extractfile="$@"
813
814     echo "Untarring ${tarfile##*/}..."
815     tar $(tarflags "$tarfile") "$tarfile" $extractfile
816
817 }
818
819 unpack_ofed() {
820
821     if ! untar "$KERNELTREE/OFED-${OFED_VERSION}.tgz"; then
822         return 1
823     fi
824     [ -d OFED ] || ln -sf OFED-[0-9].[0-9]* OFED
825
826 }
827
828 unpack_lustre() {
829
830     untar "$LUSTRE" || fatal 1 "Error unpacking Lustre tarball"
831     [ -d lustre ] || ln -sf lustre-[0-9].[0-9]* lustre
832
833 }
834
835 unpack_mpss() {
836
837     [ -d mpss ] && return 0
838
839     if [ "$MPSS_MAJ" = "3" ]; then
840         local file
841         local i
842         for i in $(seq 0 9); do
843             file="$KERNELTREE/mpss_src-${MPSS_VER}-${MPSS_BLD}-${MPSS_DISTRO}-part$i.tar"
844             if [ -r "$file" ]; then
845                 untar "$file" \
846                     "mpss-$MPSS_VER/*/linux-*.tar.bz2" \
847                     "mpss-$MPSS_VER/*/kernel-dev-*.rpm" \
848                     "mpss-$MPSS_VER/*/ofed-driver-devel-*.rpm" \
849                     "mpss-$MPSS_VER/*/ofed-driver-*-devel-*.rpm"
850             fi
851         done
852         # Extract kernel configs
853         file=$(find mpss-$MPSS_VER -type f -path "*/kernel-dev-*.rpm" -print -quit)
854         if ! rpm2cpio "$file" | cpio -idm; then
855             echo "Error extracting MPSS kernel configs"
856             return 1
857         fi
858         # Unpack kernel sources
859         file=$(find mpss-$MPSS_VER -type f -path "*/linux-*.tar.bz2" -print -quit)
860         if ! untar "$file"; then
861             echo "Error unpacking MPSS kernel sources"
862             return 1
863         fi
864         # Extract OFED headers
865         file=$(find mpss-$MPSS_VER -type f -path "*/ofed-driver-*-devel-*.rpm" -print -quit)
866         if ! rpm2cpio "$file" | cpio -idm; then
867             # Name was changed in MPSS 3.3
868             file=$(find mpss-$MPSS_VER -type f -path "*/ofed-driver-devel-*.rpm" -print -quit)
869             if ! rpm2cpio "$file" | cpio -idm; then
870                 echo "Error extracting MPSS OFED headers"
871                 return 1
872             fi
873         fi
874         # Remove unpacked archives to save space
875         rm -rf mpss-$MPSS_VER
876         # Make link to MPSS kernel sources
877         ln -sf linux-* mpss
878     else
879         local dir="mpss-${MPSS_VER}-${MPSS_BLD}-${MPSS_DISTRO%%-*}"
880
881         mkdir $dir || return 255
882         pushd $dir >/dev/null || return 255
883         if ! untar "$KERNELTREE/mpss_src-${MPSS_VER}-${MPSS_BLD}-${MPSS_DISTRO}-part0.tar" "*/gpl/*full_src*"; then
884             popd >/dev/null
885             rm -rf $dir
886             echo "Error unpacking MPSS tarball 1"
887             return 1
888         fi
889         local file=$(find . -type f -path "*/gpl/*full_src*")
890         if ! untar "$file"; then
891             popd >/dev/null
892             rm -rf $dir
893             echo "Error unpacking MPSS tarball 2"
894             return 1
895         fi
896         popd >/dev/null
897         ln -sf $dir mpss
898     fi
899
900 }
901
902 do_patch_linux() {
903
904     local do_patch=${1:-true}
905
906     FULL_PATCH="$PWD/lustre-kernel-${TARGET}-${EXTRA_VERSION}.patch"
907     [ -f "$FULL_PATCH" ] && rm -f "$FULL_PATCH"
908     $do_patch && pushd linux >/dev/null
909     for series in $SERIES; do
910         echo -n "Applying series $series:"
911         for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
912             [ -r "$patchesdir/series/$series" ] || continue
913             SERIES_FILE="$patchesdir/series/$series"
914             for patch in $(<"$SERIES_FILE"); do
915                 echo -n " $patch"
916                 PATCH_FILE="$patchesdir/patches/$patch"
917                 [ -r "$PATCH_FILE" ] || \
918                     fatal 1 "Patch $patch does not exist in Lustre tree."
919                 cat "$PATCH_FILE" >> "$FULL_PATCH" || {
920                     rm -f $FULL_PATCH
921                     fatal 1 "Error adding patch $patch to full patch."
922                 }
923                 if $do_patch; then
924                     patch -s -p1 < "$PATCH_FILE" 2>&1 || {
925                         rm -f $FULL_PATCH
926                         fatal 1 "Error applying patch $patch."
927                     }
928                 fi
929             done
930             break
931         done
932         echo
933     done
934     $do_patch && popd >/dev/null
935     echo "Full patch has been saved in ${FULL_PATCH##*/}."
936
937 }
938
939 build_lustre() {
940     local linux="$1"
941     local linuxobj="$2"
942
943     cp "$LUSTRE" SOURCES
944
945     pushd lustre >/dev/null
946
947     if ! build_lustre_dkms; then
948         popd >/dev/null # pushd lustre
949         return 255
950     fi
951
952     echo "Building Lustre RPMs for: $BUILD_ARCHS..."
953     local targets arch
954     for arch in $BUILD_ARCHS; do
955         targets="--target $arch $targets"
956     done
957
958     local rpmbuildopt='-tb'
959     if $NORPM; then
960         rpmbuildopt='-tc'
961         echo NORPM mode. Only compiling.
962     fi
963
964     # If server we now build the spl and zfs modules against the lustre kernel.
965     # These are required prior to the building of lustre server. Client does
966     # not require spl/zfs. Use !PATCHLESS to indicate server which follows the
967     # line above so is at least consistant.
968     if [ $PATCHLESS == false ] && [ "x$WITH_ZFS" == "x" ]; then
969         if ! build_spl_zfs; then
970             popd >/dev/null # pushd lustre
971             return 255
972         fi
973     fi
974
975     if $PATCHLESS; then
976         RPMBUILD_DEFS="$RPMBUILD_DEFS --without servers"
977         if [ -n "$CROSS_SUFFIX" ]; then
978             RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"lustre_name lustre-client$CROSS_SUFFIX\""
979         fi
980     fi
981
982     # ditto for the lustre-tests boolean
983     if ! $LUSTRE_TESTS; then
984         RPMBUILD_DEFS="$RPMBUILD_DEFS --without lustre_tests"
985     fi
986
987     if ! $IOKITRPM; then
988         RPMBUILD_DEFS="$RPMBUILD_DEFS --without lustre_iokit"
989     fi
990
991     local osd_zfs=""
992     if $OSDZFSRPM; then
993         osd_zfs="yes"
994     fi
995
996     local osd_ldiskfs=""
997     if $OSDLDISKFSRPM; then
998         osd_ldiskfs="yes"
999     fi
1000
1001     RPMBUILD_DEFS="$RPMBUILD_DEFS ${FIND_REQUIRES:+--define \"__find_requires $FIND_REQUIRES\"}"
1002     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"configure_args ${CONFIGURE_FLAGS}\""
1003     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"kdir $linux\""
1004     RPMBUILD_DEFS="$RPMBUILD_DEFS ${linuxobj:+--define \"kobjdir $linuxobj\"}"
1005     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_tmppath $TMPDIR\""
1006     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_topdir $TOPDIR\""
1007
1008     eval $RPMBUILD $targets $rpmbuildopt "$LUSTRE" $RPMBUILD_DEFS \
1009         ${osd_zfs:+--with zfs} \
1010         ${osd_ldiskfs:+--with ldiskfs} 2>&1 || \
1011         fatal 1 "Error building rpms for $BUILD_ARCHS."
1012
1013     if $DO_SRC; then
1014         if ! eval $RPMBUILD -ts "$LUSTRE" $RPMBUILD_DEFS 2>&1; then
1015             popd >/dev/null
1016             return 255
1017         fi
1018     fi
1019     popd >/dev/null
1020
1021 }
1022
1023 # Only zfs Lustre DKMS Server is supported
1024 build_lustre_dkms() {
1025     [ -n "$MPSS_VERSION" ] && return 0
1026     local ver=$(eval echo  $(awk '/LUSTRE_VERSION_STRING/ {print $3}'  lustre/include/lustre_ver.h))
1027     echo "Building Lustre DKMS RPMs for: $BUILD_ARCHS..."
1028     ./configure --enable-dist || return 255
1029
1030     if $PATCHLESS; then
1031         $RPMBUILD --define="_topdir $TOPDIR" --without servers -bs lustre-dkms.spec || return 255
1032         $RPMBUILD --rebuild --define="_topdir $TOPDIR" --without servers $TOPDIR/SRPMS/lustre-client-dkms-$ver-*.src.rpm || return 255
1033     else
1034         $RPMBUILD --define="_topdir $TOPDIR" -bs lustre-dkms.spec || return 255
1035         $RPMBUILD --rebuild --define="_topdir $TOPDIR" $TOPDIR/SRPMS/lustre-dkms-$ver-*.src.rpm || return 255
1036     fi
1037     return 0
1038 }
1039
1040 ###
1041 # build_spl_zfs
1042 #
1043 # Fetch spl/zfs from the git repo and prepare for lustre build
1044 #
1045 # Overrides:
1046 #   SPLZFSGITREPO - URI of directory where spl.git and zfs.git are located
1047 #   SPLZFSTAG     - Tag to checkout of clone repositories
1048 #   SPLZFSVER     - Version to checkout of both (format zfs/spl-$SPLZFSVER)
1049 #
1050 # return 0 if successful, else 255
1051 build_spl_zfs() {
1052     # make sure the RPM build environment is set up
1053     pushd $TOPDIR
1054     create_rpmbuild_dirs
1055     popd
1056
1057     # The spl/zfs spec files expect RPM_BUILD_ROOT to point to the root of the
1058     # destination for the rpms
1059     export RPM_BUILD_ROOT=$TOPDIR
1060     SPLZFSVER=${SPLZFSVER:-0.6.5.3}
1061     SPLZFSTAG=${SPLZFSTAG:-}
1062
1063     # The files expect a kver to be set to the kernel version .
1064     local kver=$(find_linux_release)
1065
1066     # build and install the spl and zfs (and -devel) RPMs for lustre to use
1067     local pkg
1068     for pkg in spl zfs; do
1069
1070         local rpmpkg
1071
1072         [ "$pkg" == "zfs" ] && spldir="$(ls -d $TOPDIR/usr/src/spl-*/|tail -1)"
1073
1074         # need to fetch the repo in order to build it.
1075         # default to github but allow override
1076         git clone ${SPLZFSGITREPO:-"https://github.com/zfsonlinux"}/$pkg.git $pkg 2>&1
1077
1078         pushd $pkg || return 255
1079         if [ -n "$SPLZFSTAG" ]; then
1080             git checkout $SPLZFSTAG
1081         else
1082             git checkout -b lbuild $pkg-$SPLZFSVER
1083         fi
1084
1085         # This differentiates between older zfs versions
1086         if [ -f $pkg-modules.spec.in ]; then
1087             rpmpkg=$pkg-modules
1088             specdir=.
1089             speclist="$pkg.spec $rpmpkg.spec"
1090         else
1091             rpmpkg=kmod-$pkg-devel
1092             specdir=rpm/generic
1093             speclist="$pkg.spec $pkg-kmod.spec $pkg-dkms.spec"
1094         fi
1095
1096         sh autogen.sh || return 255
1097
1098         if  ! ./configure --with-linux=${LINUX} --with-linux-obj=${LINUXOBJ:-$LINUX} \
1099                           ${spldir:+--with-spl="${spldir}"} 2>&1 ||
1100             ! make dist 2>&1; then
1101             popd
1102             return 255
1103         fi
1104         popd
1105
1106         ln -f $pkg/$pkg-*.tar.gz $TOPDIR/SOURCES ||
1107            error "failed to link $pkg/$pkg-*.tar.gz into $TOPDIR/SOURCES"
1108         if [ -f $pkg/scripts/kmodtool ]; then
1109             ln -f $pkg/scripts/kmodtool $TOPDIR/SOURCES/
1110         fi
1111
1112         local rpmb
1113         if $DO_SRC; then
1114             rpmb=-ba
1115         else
1116             rpmb=-bb
1117         fi
1118
1119         # set search dir for our own kmodtool to find correct
1120         # directories
1121         export KERNELSOURCE=$(dirname ${LINUX})
1122         # Manually build rpms
1123         for spec in $speclist; do
1124             echo "Building RPMs from $pkg/$specdir/$spec"
1125             if ! $RPMBUILD $rpmb $pkg/$specdir/$spec \
1126                 --nodeps -v \
1127                 --define "require_kdir ${LINUX}" \
1128                 ${LINUXOBJ:+--define "require_kobj ${LINUXOBJ}"} \
1129                 ${spldir:+--define "require_spldir ${spldir}"} \
1130                 --define "kver $kver" \
1131                 --define "kernels $kver" \
1132                 --define "_tmppath /var/tmp" \
1133                 --define "kernelbuildroot $TOPDIR/reused" \
1134                 --define "_topdir $TOPDIR" 2>&1; then
1135                 return 255
1136             fi
1137         done
1138
1139         # We have built the rpms for the package. Now we need to extract the
1140         # contained files so we can build further things against them
1141         local rpms=$(ls -1 $TOPDIR/RPMS/*/$rpmpkg-*.rpm)
1142
1143         # cpio only extract to pwd so we need to go there.
1144         pushd $TOPDIR
1145         local rpm
1146         for rpm in $rpms; do
1147             rpm2cpio $rpm | cpio -id
1148         done
1149
1150         if [ "$pkg" == "zfs" ]; then
1151             # We also need to extract both the zfs and zfs-devel rpms
1152             # the zfs rpm is needed because it has the actual libraries in
1153             # it and the zfs-devel rpm only has unversioned symlinks to the
1154             # libraries in the zfs rpm
1155             # this will all change one day when we have a libzfs rpm per
1156             # https://github.com/zfsonlinux/zfs/issues/2329
1157             # and it looks like it could be one day soon:
1158             # https://github.com/zfsonlinux/zfs/pull/2341
1159             local devel_rpms=$(ls -1 $TOPDIR/RPMS/*/{$pkg-devel,$pkg-$SPLZFSVER,lib*}-*.rpm)
1160             for rpm in $devel_rpms; do
1161                 rpm2cpio $rpm | cpio -id
1162             done
1163             CONFIGURE_FLAGS="--with-$pkg-devel=$TOPDIR ${CONFIGURE_FLAGS}"
1164         fi
1165         popd
1166
1167         CONFIGURE_FLAGS="--with-$pkg=$(ls -d $TOPDIR/usr/src/$pkg-*/|tail -1) ${CONFIGURE_FLAGS}"
1168         CONFIGURE_FLAGS="--with-$pkg-obj=$(ls -d $TOPDIR/usr/src/$pkg-*/$kver*|tail -1) ${CONFIGURE_FLAGS}"
1169     done
1170
1171     OSDZFSRPM=true
1172
1173     return 0
1174 }
1175
1176 prepare_mpss() {
1177
1178     pushd mpss >/dev/null || return 255
1179     if [ "$MPSS_MAJ" = "3" ]; then
1180         cp -f ../boot/config-* .config
1181         if ! make ARCH=k1om silentoldconfig ; then
1182             popd >/dev/null
1183             return 1
1184         fi
1185         if ! make ARCH=k1om modules_prepare ; then
1186             popd >/dev/null
1187             return 1
1188         fi
1189         cp -f ../boot/Module.symvers-* Module.symvers
1190     else
1191         if ! make defconfig-miclinux; then
1192             popd >/dev/null
1193             return 1
1194         fi
1195         if ! make -C card/kernel ARCH=k1om modules_prepare ; then
1196             popd >/dev/null
1197             return 1
1198         fi
1199     fi
1200     popd >/dev/null
1201
1202 }
1203
1204 stage() {
1205
1206     [ "$STAGEDIR" ] || return 0
1207
1208     for arch in $BUILD_ARCHS; do
1209         rpmdir="${STAGEDIR}/${CANONICAL_TARGET}-${arch}"
1210         echo "${0##*/}: Copying RPMs into ${rpmdir}"
1211         mkdir -p "${rpmdir}"
1212         cp -v RPMS/${arch}/*.rpm "${rpmdir}"
1213         if [ -d RPMS/noarch ]; then
1214             cp -v RPMS/noarch/*.rpm "${rpmdir}"
1215         fi
1216     done
1217
1218     cp -v "$LUSTRE" "$STAGEDIR"
1219
1220 }
1221
1222 set_rpm_smp_type() {
1223
1224     local infact_arch="${TARGET_ARCH}"
1225
1226     RPMSMPTYPE=""
1227     [ "$infact_arch" == "i586" ] && infact_arch="i686"
1228
1229     local smp_type
1230     for smp_type in $SMP_ARCHS; do
1231         [ $infact_arch == $smp_type ] && RPMSMPTYPE=smp && break
1232     done
1233
1234     for smp_type in $BIGSMP_ARCHS; do
1235         [ $infact_arch == $smp_type ] && RPMSMPTYPE=bigsmp && break
1236     done
1237
1238     for smp_type in $PPC64_ARCHS; do
1239         [ $infact_arch == $smp_type ] && RPMSMPTYPE=ppc64 && break
1240     done
1241
1242     for smp_type in $DEFAULT_ARCHS; do
1243         [ $infact_arch == $smp_type ] && RPMSMPTYPE=default && break
1244     done
1245
1246 }
1247
1248 # This function takes a linux include tree and digs out the linux release
1249 # from it. It is never called directly, only called from the distro
1250 # specific function find_linux_release() in lbuild-{rhel,sles}.
1251 _find_linux_release() {
1252     local SRC="$1"
1253     local LINUXRELEASEHEADER=""
1254
1255     LINUXRELEASEHEADER=$SRC/include/linux/version.h
1256     if [ -s $SRC/include/generated/utsrelease.h ]; then
1257         LINUXRELEASEHEADER=$SRC/include/generated/utsrelease.h
1258     elif [ -s $SRC/include/linux/utsrelease.h ]; then
1259         LINUXRELEASEHEADER=$SRC/include/linux/utsrelease.h
1260     fi
1261
1262     if [ ! -s $LINUXRELEASEHEADER ]; then
1263         fatal 1 "could not find UTS_RELEASE"
1264     fi
1265
1266     sed -ne 's/#define UTS_RELEASE "\(.*\)"$/\1/p' $LINUXRELEASEHEADER
1267 }
1268
1269 # unpack kernel(/source/devel) RPM
1270 #
1271 # This function and it's setting of $LINUX and $LINUXOBJ is a total hack that
1272 # needs to completely refactored.  It completely ingores that $BUILD_ARCHS may
1273 # contain a list of arches for which rpmbuild commands (including the one for
1274 # lustre itself)
1275 unpack_linux_devel_rpm() {
1276     local kernelrpm="${1}"
1277
1278     [ -f "$kernelrpm" ] || return 255
1279     [ -d $TOPDIR/reused ] || mkdir $TOPDIR/reused || return 255
1280
1281     pushd $TOPDIR/reused &>/dev/null || return 255
1282
1283     if ! rpm2cpio < "$kernelrpm" | cpio -id > /dev/null 2>&1; then
1284         return 255
1285     fi
1286
1287     # call a distro specific hook, if available
1288     if type -p unpack_linux_devel_rpm-$DISTROMAJ; then
1289         if ! unpack_linux_devel_rpm-$DISTROMAJ "$kernelrpm"; then
1290             return 255
1291         fi
1292     fi
1293
1294     popd &>/dev/null
1295
1296     find_linux_devel_paths $TOPDIR/reused
1297
1298     return 0
1299
1300 }
1301
1302 build_kernel_ib() {
1303     local linux="$1"
1304     local kib_prefix="$2"
1305     local kib_rpm="$3"
1306
1307     # build kernel-ib{,-devel}/compat-rdma{,-devel}
1308     local K_SRC="K_SRC"
1309     # ofed 1.3 had a bug in the rpm spec
1310     if [ "$OFED_VERSION" = "1.3" ]; then
1311         K_SRC="KSRC"
1312     fi
1313
1314     local OFED_CORE="--with-core-mod --with-ipoib-mod --with-user_mad-mod --with-user_access-mod --with-addr_trans-mod"
1315     local OFED_HARDWARE="--with-mthca-mod --with-mlx4-mod --with-mlx4_en-mod --with-cxgb3-mod --with-nes-mod --with-qib-mod"
1316
1317     if compare_version $OFED_VERSION 3.0; then
1318         OFED_CORE="$OFED_CORE --with-madeye-mod --with-rds-mod"
1319     else
1320         OFED_HARDWARE="$OFED_HARDWARE --with-mlx5-mod --with-cxgb4-mod --with-ocrdma-mod --with-qib-mod"
1321     fi
1322
1323     # some I/B drivers are architecture dependent and kernel-ib's configure
1324     # does not figure it out for us ~sigh~
1325     case "$TARGET_ARCH" in
1326         ppc64)
1327             OFED_HARDWARE="$OFED_HARDWARE --with-ehca-mod"
1328             ;;
1329     esac
1330     # we're no longer shipping the OFED iSCSI target
1331     #OFED_ISCSI="--with-srp-mod --with-srp-target-mod"
1332     OFED_ISCSI="--with-srp-mod"
1333     ## ISER module has no backport support as of OFED 1.5 (i.e. only builds on
1334     ##kernels >= 2.6.30)
1335     #if [[ $OFED_VERSION = 1.[0-4]* ]]; then
1336     #   OFED_ISCSI="$OFED_ISCSI --with-iser-mod"
1337     #fi
1338
1339     # assume we are just rebuilding the SRPM
1340     local BUILD_TYPE=${BUILD_TYPE:-"--rebuild"}
1341     local SOURCE="${TOPDIR}/OFED/SRPMS/${kib_prefix}-*.src.rpm"
1342
1343     # but switch to building from the SPEC if we need to apply patches
1344     if ls ${TOPDIR}/lustre/contrib/patches/ofed/* >/dev/null; then
1345         BUILD_TYPE="-bb"
1346         rpm --define "_topdir ${TOPDIR}" -ivh $SOURCE
1347         SOURCE="${TOPDIR}/SPECS/${kib_prefix}.spec"
1348         local file ed_fragment1 ed_fragment2 n=1
1349         for file in $(ls ${TOPDIR}/lustre/contrib/patches/ofed/*.patch); do
1350             ed_fragment1="$ed_fragment1
1351 Patch$n: ${file%%*/}"
1352             ed_fragment2="$ed_fragment2
1353 %patch$n -p0"
1354             cp $file ${TOPDIR}/SOURCES
1355             let n=$n+1
1356         done
1357         for file in $(ls ${TOPDIR}/lustre/contrib/patches/ofed/*.ed); do
1358             # Only apply the ed-scripts that should be used for the canonical target
1359             # ed-files in ${TOPDIR}/lustre/contrib/patches/ofed/ have to follow the naming
1360             # convention
1361             # <two-digits>-<descriptive-name>:<canonical_target_1>: ...:<canonical_target_N>.ed
1362             # To apply the same change to multiple canonical target simply specify
1363             # a list of colon separated canoncial target names in the file name.
1364             echo "$file" | grep -q -e ":${CANONICAL_TARGET}:" \
1365                                    -e ":${CANONICAL_TARGET}.ed$"
1366             if [ $? -eq 0 ] ; then
1367                 ed_fragment3="$ed_fragment3
1368 $(cat $file)"
1369                 let n=$n+1
1370             fi
1371         done
1372
1373         if [ $n -gt 1 ]; then
1374             ed $SOURCE <<EOF
1375 /^Source: /a
1376 $ed_fragment1
1377 .
1378 /^%setup /a
1379 $ed_fragment2
1380 .
1381 $ed_fragment3
1382 wq
1383 EOF
1384         fi
1385     fi
1386
1387     local linuxrelease=$(find_linux_release)
1388     if compare_version $OFED_VERSION 3.0; then
1389         local OFA_KERNEL_RELEASE=$(echo -n ${linuxrelease} | sed -e 's/-/_/g')
1390     fi
1391     if ! $RPMBUILD $BUILD_TYPE --define 'build_kernel_ib 1' --define 'build_kernel_ib_devel 1' \
1392                   ${FIND_REQUIRES:+--define "__find_requires $FIND_REQUIRES"} \
1393                   --define "_topdir ${TOPDIR}" --target ${TARGET_ARCH} \
1394                   --define "KVERSION ${linuxrelease}" \
1395                   --define "$K_SRC ${linux}" \
1396                   --define "LIB_MOD_DIR /lib/modules/${linuxrelease}/updates" \
1397                   ${OFA_KERNEL_RELEASE:+--define "_release $OFA_KERNEL_RELEASE"} \
1398                   --define "configure_options --without-quilt $OFED_CORE $OFED_HARDWARE $OFED_ISCSI" \
1399                   ${SOURCE} 2>&1; then
1400         fatal 1 "Error building ${kib_rpm}"
1401     fi
1402
1403 }
1404
1405 store_for_reuse() {
1406     local articles="$1"
1407     local module="$2"
1408     local location="$3"
1409     local signature="$4"
1410     local use_links="$5"
1411
1412     local linkflag=""
1413     if $use_links; then
1414         linkflag="l"
1415     fi
1416
1417     local default_iface=$(/sbin/ip route get 192.1.1.1 | sed -ne 's/.* dev \(.*\)  * src .*/\1/p')
1418     if [ -z "$default_iface" ]; then
1419         fatal 1 "Failed to determine the default route interface"
1420     fi
1421     local unique_id=$(/sbin/ip addr show dev $default_iface | sed -ne '/ inet /s/ *inet \(.*\)\/.*/\1/p' | head -1)
1422     if [ -z "$unique_id" ]; then
1423         fatal 1 "Failed to determine a unique id from interface $default_interface"
1424     fi
1425
1426     local finallocation="$location"/"$signature"/"$module"
1427     location="$location"/"$signature-${unique_id}"/"$module"
1428     mkdir -p "$location"
1429     # the cleanup script removes any directory that doesn't have a
1430     # .lastused, so let's try to prevent that as soon as we can
1431     # this solution still slightly racy with the cleanup script
1432     # but the race is a lot tighter now
1433     touch -t 197001010000 "$location/.lastused"
1434     ## use eval/echo here to make sure shell expansions are performed
1435     #if ! cp -a${linkflag} $(eval echo $articles) "$location"; then
1436     local article
1437     for article in $(eval echo $articles); do
1438         if ! cp -a${linkflag} "$article" "$location"; then
1439             error "Failed to copy \"$article\" to \"$location\" in store_for_reuse()"
1440             # rename the cache location so that it's not cached
1441             # product, but is around for analysis
1442             mv "$location"{,-bad-$(date +%s)} ||
1443                 error "failed to clean up a failed cache attempt" \
1444                       "in \"$location\" -- manual cleanup will be" \
1445                       "necessary"
1446             return 1
1447         fi
1448     done
1449
1450     # flag the cache as complete (i.e. in case lbuild was previously
1451     # interrupted while caching)
1452     touch "$location/.lastused"
1453
1454     # put the temporary location into the final location
1455     # (last one wins)
1456     mkdir -p "${finallocation%/*}"
1457     mv "$location" "$finallocation"
1458     rmdir "${location%/*}"
1459     return 0
1460
1461 }
1462
1463 reuse() {
1464     local module="$1"
1465     local dest="$2"
1466     local use_links="${3:-false}"
1467     local signature="$4"
1468
1469     if [ -n "$REUSEBUILD" ] && [ -d "$REUSEBUILD/$signature/$module" ]; then
1470         if [ ! -f "$REUSEBUILD/$signature/$module/.lastused" ]; then
1471             # the .lastused flag is populated at the end of the caching to
1472             # signal that the caching was completed.  if that flag is not
1473             # there, then the cache is invalid (and should be removed in fact)
1474             mv "$REUSEBUILD/$signature/$module"{,-bad-$(date +%s)} ||
1475                 fatal 1 "failed to clean up a bad cache in location $REUSEBUILD/$signature/$module\" -- manual cleanup will be necessary"
1476             return 1
1477         fi
1478
1479         # so that we know how stale this entry is
1480         touch $REUSEBUILD/$signature/$module/.lastused
1481
1482         if $use_links; then
1483             if ls $REUSEBUILD/$signature/$module/* >/dev/null 2>&1; then
1484                 cp -al $REUSEBUILD/$signature/$module/* $dest/
1485             fi
1486         else
1487             # copying is pretty heavy
1488             # cp -a $REUSEBUILD/$signature/$module/* $dest/
1489             # do some creative symlinking instead
1490             local dir
1491             for dir in BUILD SRPMS SPECS; do
1492                 if ls $REUSEBUILD/$signature/$module/$dir/* >/dev/null 2>&1; then
1493                     ln -s $REUSEBUILD/$signature/$module/$dir/* $dest/$dir
1494                 fi
1495             done
1496             # sources have to be copied by file because we need SOURCES to
1497             # be a dir we can write into
1498 # could overrun ls's arg list here
1499             #ls $REUSEBUILD/$signature/$module/SOURCES/* |
1500             find $REUSEBUILD/$signature/$module/SOURCES/ -type f |
1501                 xargs ln -t $dest/SOURCES -s
1502
1503             # same for RPMS/* dirs
1504 # could overrun ls's arg list here
1505             #ls $REUSEBUILD/$signature/$module/RPMS/$TARGET_ARCH/* |
1506             local dir
1507             for dir in $REUSEBUILD/$signature/$module/RPMS/*; do
1508                 mkdir -p $dest/RPMS/${dir##*/}
1509                 find $dir -type f |
1510                   xargs ln -t $dest/RPMS/${dir##*/} -s
1511             done
1512         fi
1513         return 0
1514     else
1515         return 1
1516     fi
1517 }
1518
1519 basearch() {
1520     local arch="$1"
1521
1522     if [[ $arch = i[3456]86 ]]; then
1523         echo "i386"
1524     else
1525         echo "$arch"
1526     fi
1527
1528 }
1529
1530 build_kernel_with_srpm() {
1531     local outfd=$1
1532
1533     if [ -z "$outfd" ] || [ $outfd = 1 ]; then
1534         fatal 1 "You must supply a file descriptor to ${FUNCNAME[0]} and it cannot be 1"
1535     fi
1536
1537     # need to generate the patch for this target
1538     do_patch_linux false >&${outfd}    # sets global $FULL_PATCH (yeah, yuck)
1539
1540     # get an md5sum of the kernel patch + config for reuse check
1541     # XXX really, there needs to be a signature and a CONFIG_FILE per arch
1542     #     in BUILD_ARCHS
1543     local release_str
1544     if $RELEASE; then
1545         local release_str="RELEASE=$RELEASE\n"
1546     fi
1547
1548     if $USE_BUILD_CACHE && [ -n "$REUSEBUILD" ]; then
1549         local REUSE_SIGNATURE=$({ echo -en $release_str;
1550                                   echo $BUILD_GEN;
1551                                   cat "$CONFIG_FILE";
1552                                   cat "$TARGET_FILE";
1553                                   cat "$FULL_PATCH";
1554                                   cat "$LBUILD_DIR/lbuild";
1555                                   cat "$LBUILD_DIR/lbuild-$DISTROMAJ"; } |
1556                                 md5sum | cut -d" " -f1)
1557         # see if we can link to the reuse pool
1558         # XXX - hrm.  i'm not convinced this doesn't belong in the reuse
1559         #       "library"
1560         local CAN_LINK_FOR_REUSE=false
1561         touch $REUSEBUILD/$$
1562         if cp -al $REUSEBUILD/$$ $TOPDIR/ 2>/dev/null; then
1563             CAN_LINK_FOR_REUSE=true
1564         fi
1565         rm $REUSEBUILD/$$
1566     fi
1567
1568     # the extra version string to use for the kernel (which might be a reused
1569     # kernel, remember)
1570     local kernel_extra_version=""
1571     if ! $USE_BUILD_CACHE || ! reuse kernel "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1572                                    "$REUSE_SIGNATURE"; then
1573         # nothing cached, build from scratch
1574         if [ ! -r "$KERNELDIR/$KERNEL_SRPM" ]; then
1575             echo "Downloading kernel SRPM" >&${outfd}
1576             download_srpm "$CANONICAL_TARGET" "$KERNEL_SRPM" >&${outfd}
1577         fi
1578
1579         if ! rpm -ivh $KERNELDIR/$KERNEL_SRPM \
1580                   --define "_topdir $TOPDIR" >&${outfd} 2>&1; then
1581             # should we clean this up or leave it for analysis?
1582             #rm -rf $RPMTOPDIR
1583             fatal 1 "Error installing kernel SRPM."
1584         fi
1585
1586         # put the Lustre kernel patch into the RPM build tree
1587         cp $FULL_PATCH $TOPDIR/SOURCES/linux-${lnxmaj}-lustre.patch
1588         prepare_and_build_srpm >&${outfd} ||
1589             fatal 1 "failed to prepare_and_build_srpm"
1590
1591         if [ -z "$REUSE_SIGNATURE" ]; then
1592             echo "No reuse signature was caculated so not storing the built kernel" >&${outfd}
1593         else
1594             # store the resulting kernel RPM build tree for future use
1595             echo "Storing the built kernel for future reuse" >&${outfd}
1596             if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,SRPMS,RPMS}" \
1597                                  "kernel" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1598                                  "$CAN_LINK_FOR_REUSE"; then
1599                 error "Failed to store kernel RPMS for reuse"
1600                 echo "unknown" >&${outfd}
1601                 return 1
1602             fi
1603         fi
1604     fi  # build reuse
1605
1606     # figure out the EXTRA_VERSION of the kernel we built or are re-using
1607     local KERNEL_RPM
1608     if ! KERNEL_RPM=$(find_rpm "$TOPDIR/RPMS/$TARGET_ARCH/" provides "^kernel(-default)? ="); then
1609         fatal 1 "Failed to find a kernel RPM in $TOPDIR/RPMS/$TARGET_ARCH/"
1610     fi
1611     kernel_extra_version=$(rpm -q --queryformat "%{RELEASE}" -p $TOPDIR/RPMS/$TARGET_ARCH/$KERNEL_RPM)
1612
1613     # should now have the following RPMs
1614     # $TOPDIR/RPMS/$arch/kernel-lustre-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1615     # $TOPDIR/RPMS/$arch/kernel-lustre-devel-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1616     # $TOPDIR/RPMS/$arch/kernel-lustre-headers-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1617     # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-common-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1618     # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1619
1620     echo $kernel_extra_version
1621     return 0
1622
1623 }
1624
1625 # build OFED
1626 # globals used:
1627 #    TOPDIR
1628 #    REUSEBUILD, USE_BUILD_CACHE
1629 #    CONFIGURE_FLAGS
1630
1631 build_ofed() {
1632     local linux="$1"
1633     local ofed_version="$2"
1634     local kib_prefix
1635     local kib_rpm
1636
1637     # if an ofed version is given, then it means use OFED proper,
1638     # not any vendor specific "inkernel" version
1639     if [ -z "$ofed_version" ]; then
1640         return 0
1641     fi
1642
1643     if [ "$ofed_version" = "inkernel" ]; then
1644         # see if there is a distro specific override for this and use
1645         # that if it exists
1646         # XXX we need to better integrate a distro specific override with
1647         #     the rest of this function so that all of the reuse cache
1648         #     stuff is leveraged given that 80% of this function is reuse
1649         if type -p build_ofed-$DISTROMAJ; then
1650             local ofed_location
1651             ofed_location=$(build_ofed-$DISTROMAJ ${STDOUT})
1652             local rc=${PIPESTATUS[0]}
1653             CONFIGURE_FLAGS="--with-o2ib=${ofed_location} ${CONFIGURE_FLAGS}"
1654             return $rc
1655         else
1656             return 0
1657         fi
1658     elif compare_version $OFED_VERSION 3.0; then
1659         kib_prefix="ofa_kernel"
1660         kib_rpm="kernel-ib"
1661     else
1662         kib_prefix="compat-rdma"
1663         kib_rpm="compat-rdma"
1664     fi
1665
1666     # build kernel-ib/compat-rdma
1667     if $USE_BUILD_CACHE && [ -n "$REUSEBUILD" ]; then
1668         local REUSE_SIGNATURE=$({ echo "$ofed_version";
1669                                   echo "$(find_linux_release;
1670                                   echo "$BUILD_GEN")";
1671                                   cat "${linux}/include/linux/autoconf.h";
1672                                   cat "$LBUILD_DIR/lbuild";
1673                                   cat "$LBUILD_DIR/lbuild-$DISTROMAJ"; } |
1674                                 md5sum | cut -d" " -f1)
1675         # see if we can link to the reuse pool
1676         # XXX - hrm.  i'm not convinced this doesn't belong in the reuse
1677         #       "library"
1678         local CAN_LINK_FOR_REUSE=false
1679         touch $REUSEBUILD/$$
1680         if cp -al $REUSEBUILD/$$ $TOPDIR/; then
1681             CAN_LINK_FOR_REUSE=true
1682         fi
1683         rm $REUSEBUILD/$$
1684     fi
1685
1686     if ! $USE_BUILD_CACHE || ! reuse ofed "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1687                                    "$REUSE_SIGNATURE"; then
1688         if [ -n "$REUSE_SIGNATURE" ]; then
1689             # stash away the existing built articles for a moment
1690             mkdir bak
1691             mv {BUILD,{S,}RPMS,S{OURCE,PEC}S} bak
1692             function mv_back {
1693                 pushd bak
1694                 find . | cpio -pudlm ..
1695                 popd
1696                 rm -rf bak
1697             }
1698             create_rpmbuild_dirs
1699         fi
1700         # build it
1701         build_kernel_ib "${linux}" "${kib_prefix}" "${kib_rpm}"
1702
1703         if [ -z "$REUSE_SIGNATURE" ]; then
1704             echo "No reuse signature was caculated so not storing the built ofed"
1705         else
1706             # store the resulting RPM build tree for future use
1707             echo "Storing the built ofed for future reuse"
1708             if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,BUILD,SRPMS,RPMS}" \
1709                                  "ofed" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1710                                  "$CAN_LINK_FOR_REUSE"; then
1711                 error "Failed to store OFED RPMS for reuse"
1712                 mv_back
1713                 return 1
1714             fi
1715             # put the stuff we stashed away back
1716             mv_back
1717         fi
1718     fi
1719
1720     pushd "$TOPDIR" >/dev/null
1721     rm -rf ${kib_rpm}-devel
1722     mkdir ${kib_rpm}-devel
1723     cd ${kib_rpm}-devel
1724     # the actual ofed RPMs don't have the -rc$n or -$date string appened that
1725     # might be present on the file
1726     #local linuxrelease=$(find_linux_release)
1727     #ofed_version=$(echo $ofed_version |
1728     #               sed -re 's/-(20[0-9]{6,6}-[0-9]{4,4}|rc[0-9]*)$//')
1729     # FIXME
1730     # OFED version will have 'hyphen' for minor release. (e.g. 3.5-1, instead
1731     # of 3.5.1) compat-rdma and compat-rdma-devel could have same version
1732     # number, but currectly not. Once OFED fix this in the future release, we
1733     # can remove following filter.
1734     #ofed_version=$(echo $ofed_version |
1735     #               sed -re 's/-([0-9]*-[rR][cC][0-9]*)$//')
1736     #local rpm=$(ls $TOPDIR/RPMS/*/${kib_rpm}-devel-${ofed_version}-${linuxrelease//-/_}.*.rpm)
1737     # I dont' know why we have gone through the trouble to filter out the name
1738     # of the rpm there should only be one ${kib_rpm}-devel built
1739     local rpm=$(ls $TOPDIR/RPMS/*/${kib_rpm}-devel-*.rpm)
1740     if ! rpm2cpio < $rpm | cpio -id; then
1741         fatal 1 "could not unpack the ${kib_rpm}-devel rpm."
1742     fi
1743     CONFIGURE_FLAGS="--with-o2ib=$(pwd)/usr/src/${kib_prefix} ${CONFIGURE_FLAGS}"
1744     popd >/dev/null
1745
1746 }
1747
1748 build_with_srpm() {
1749
1750     if ! $PATCHLESS; then
1751         local kernel_extra_version
1752         if ! kernel_extra_version=$(build_kernel_with_srpm ${STDOUT}); then
1753             fatal 1 "Failed to build the kernel from it's SRPM"
1754         fi
1755
1756         for arch in $BUILD_ARCHS; do
1757             local kernel_devel_rpm
1758             if ! kernel_devel_rpm=$(find_rpm "$TOPDIR/RPMS/$arch/" provides "^$(devel_kernel_name $KERNEL_LUSTRE_NAMING) ="); then
1759                 fatal 1 "Failed to find a kernel development RPM in $TOPDIR/RPMS/$arch/"
1760             fi
1761
1762             # install the -devel RPM in preparation for modules builds
1763             if ! lnxrel="$kernel_extra_version" unpack_linux_devel_rpm \
1764                            "$TOPDIR/RPMS/$arch/$kernel_devel_rpm"; then
1765                 fatal 1 "Could not find the Linux tree in $TOPDIR/RPMS/$arch/$kernel_devel_rpm"
1766             fi
1767         done
1768     else
1769         # need to find and unpack the vendor's own kernel-devel for patchless
1770         # client build
1771         local kernelrpm
1772         if ! kernelrpm=$(find_linux_rpm "-$DEVEL_KERNEL_TYPE"); then
1773             fatal 1 "Could not find the kernel-$DEVEL_KERNEL_TYPE RPM in $KERNELRPMSBASE/$lnxmaj/$DISTROMAJ"
1774         fi
1775         if ! lnxrel="$lnxrel" unpack_linux_devel_rpm "$kernelrpm" "-"; then
1776             fatal 1 "Could not find the Linux tree in $kernelrpm"
1777         fi
1778     fi
1779
1780     # ~sigh~  have to make copies of and modify some of the rpm
1781     # infrastructure files so that find-requires can find our unpacked
1782     # kernel-devel artifacts
1783     cp $RPM_HELPERS_DIR/{symset-table,find-requires{,.ksyms}} .
1784     FIND_REQUIRES="$(pwd)/find-requires"
1785     chmod 755 {symset-table,find-requires{,.ksyms}}
1786     local tmp="$(pwd)"
1787     tmp="${tmp//\//\\/}"
1788     ed find-requires <<EOF
1789 1a
1790 set -x
1791 .
1792 /|.*find-requires.ksyms/s/|/| bash -x/
1793 g/ [^ ]*\/\(find-requires\.ksyms\)/s// $tmp\/\1/g
1794 wq
1795 EOF
1796     ed find-requires.ksyms <<EOF
1797 1a
1798 set -x
1799 .
1800 g/\/.*\/\(symset-table\)/s//$tmp\/\1/g
1801 wq
1802 EOF
1803     ed symset-table <<EOF
1804 1a
1805 set -x
1806 .
1807 g/\(\/boot\/\)/s//$tmp\/reused\1/g
1808 g/\(\/usr\/src\/kernels\/\)/s//$tmp\/reused\1/g
1809 wq
1810 EOF
1811
1812     build_ofed "${LINUXOBJ:-$LINUX}" "$OFED_VERSION" ||
1813         fatal 1 "error building OFED"
1814
1815     # now build Lustre
1816     if build_lustre "$LINUX" "$LINUXOBJ"; then
1817         # the build worked.  resolve any symlinked files (i.e. from reuse)
1818         # in RPMS/$arch to real files so that that that huge mess of
1819         # complication known as LTS can copy them yet somewhere else.
1820         # is it any wonder this whole process is so damn so?  anyone ever
1821         # heard of hardlinks?  it's this cool new thing that allows you save
1822         # tons of time and space by creating... well you can go read about
1823         # them if you have not heard about them yet.
1824         # can i say how much the implemenation of all of this really impedes
1825         # RPM reuse?
1826         local dir
1827         for dir in RPMS/*; do
1828             pushd $dir
1829             for file in $(ls); do
1830                 if [ -h $file ]; then
1831                     cp $file foo
1832                     mv foo $file
1833                 fi
1834             done
1835             popd
1836         done
1837         # also, for i?86, make sure all of the RPMs are in RPMS/$TARGET_ARCH
1838         # as that's where LTS expects to find them
1839         for dir in RPMS/*; do
1840             if [ $dir = RPMS/$TARGET_ARCH ]; then
1841                 continue
1842             fi
1843             pushd $dir
1844             local files=$(ls)
1845             if [ -n "$files" ]; then
1846                 cp -al $files ../$TARGET_ARCH
1847             fi
1848             popd
1849         done
1850     else
1851         return 1
1852     fi
1853
1854 }
1855
1856 create_rpmbuild_dirs() {
1857
1858     [ -d RPMS ] || mkdir RPMS
1859     for arch in $BUILD_ARCHS; do
1860         if [[ $arch = i?86 ]]; then
1861             # some stupidity in the sles11 kernel spec requires an RPMS/i386
1862             # even if the target arch is i686
1863             [ -d RPMS/i386 ] || mkdir RPMS/i386
1864         fi
1865         [ -d RPMS/$arch ] || mkdir RPMS/$arch
1866     done
1867     [ -d RPMS/noarch ] || mkdir RPMS/noarch
1868     [ -d BUILD ] || mkdir BUILD
1869     [ -d SOURCES ] || mkdir SOURCES
1870     [ -d SPECS ] || mkdir SPECS
1871     [ -d SRPMS ] || mkdir SRPMS
1872
1873 }
1874
1875 new_list() {
1876
1877     echo ""
1878
1879 }
1880
1881 add_list() {
1882     local list="$1"
1883     local item="$2"
1884
1885     echo "$list $item"
1886
1887 }
1888
1889 is_list_member() {
1890     local list="$1"
1891     local item="$2"
1892
1893     [[ $list\  == *\ $item\ * ]]
1894
1895 }
1896
1897 #########################################################################
1898 # Generate a backtrace through the call stack.
1899 #
1900 # Input: None
1901 # Output: None
1902 #########################################################################
1903 backtrace() {
1904     local strip=${1:-1}
1905
1906     local funcname="" sourcefile="" lineno="" n
1907
1908     echo "Call stack: (most recent first)"
1909     for (( n = $strip ; n < ${#FUNCNAME[@]} ; ++n )) ; do
1910         funcname=${FUNCNAME[$n - 1]}
1911         sourcefile=$(basename ${BASH_SOURCE[$n]})
1912         lineno=${BASH_LINENO[$n - 1]}
1913         if [ $n = 1 ]; then
1914             let lineno-=11
1915         fi
1916         # Display function arguments
1917         if [[ ! -z "${BASH_ARGV[@]}" ]]; then
1918             local args newarg j p=0
1919             for (( j = ${BASH_ARGC[$n - 1]}; j > 0; j-- )); do
1920                 newarg=${BASH_ARGV[$j + $p - 1]}
1921                 args="${args:+${args} }'${newarg}'"
1922             done
1923             let p+=${BASH_ARGC[$n - 1]}
1924         fi
1925         echo "  ${funcname} ${args:+${args} }at ${sourcefile}:${lineno}"
1926     done
1927
1928     echo
1929     echo "BEGIN BACKTRACE"
1930
1931     #echo ${BASH_LINENO[*]}
1932     #echo ${BASH_SOURCE[*]}
1933     #echo ${FUNCNAME[*]}
1934     local i=$((${#FUNCNAME[@]} - 1))
1935     while [ $i -ge 0 ]; do
1936         local lineno=${BASH_LINENO[$i]}
1937         if [ $i = 0 ]; then
1938             let lineno-=11
1939         fi
1940         local SOURCELINE="${BASH_SOURCE[$i + 1]}:${lineno}"
1941         # Can't figure out how to get function args from other frames...
1942         local FUNCTION="${FUNCNAME[$i]}()"
1943         echo "$SOURCELINE:$FUNCTION"
1944         i=$((i - 1))
1945     done
1946
1947     echo "END BACKTRACE"
1948
1949     echo $BACKTRACE
1950
1951 }
1952
1953 seen_list=$(new_list)
1954 trap 'set +x;
1955 echo "An unexpected error has occurred at ${BASH_SOURCE[0]##*/}:$((LINENO-1)).
1956 Unfortunately the above line number in the message may or may not be correct,
1957 but details have been send to the lbuild maintainer.  Attempting to continue."; (echo "Untrapped error"
1958 echo
1959 # have we seen this one
1960 echo "checking seen list for ${BASH_SOURCE[0]}:${BASH_LINENO[0]}"
1961
1962 if is_list_member "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}"; then
1963   echo "seen this one already"
1964 else
1965   seen_list=$(add_list "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}")
1966 fi
1967 backtrace
1968 ) ; set $xtrace' ERR
1969 set -E
1970
1971 [ -r ~/.lbuildrc ] && . ~/.lbuildrc
1972
1973 options=$(getopt -o D:h -l kerneltree:,distro:,kernelrpm:,reusebuild:,patchless,ccache,norpm,external-patches:,timestamp:,extraversion:,kerneldir:,linux:,lustre:,nodownload,nosrc,noiokit,ofed-version:,mpss-version:,publish,disable-zfs,release,set-value:,src,stage:,target:,target-archs:,with-linux:,xen -- "$@")
1974
1975 if [ $? != 0 ]; then
1976     usage 1
1977 fi
1978
1979 eval set -- "$options"
1980
1981 while [ "$1" ]; do
1982     case "$1" in
1983         '')
1984             usage 1
1985             ;;
1986         --ccache)
1987             CCACHE='ccache'
1988             shift
1989             ;;
1990         -D)
1991             DATE=$2
1992             shift 2
1993             ;;
1994         --external-patches)
1995             EXTERNAL_PATCHES=$2
1996             shift 2
1997             ;;
1998         --extraversion)
1999             EXTRA_VERSION=$2
2000             shift 2
2001             ;;
2002         --help | -h)
2003             usage 0
2004             ;;
2005         --kerneldir)
2006             KERNELDIR=$2
2007             shift 2
2008             ;;
2009         --kerneltree)
2010             if ! KERNELTREE=$(canon_path "$2"); then
2011                 fatal 1 "Could not determine the canonical location of $2"
2012             fi
2013             shift 2
2014             ;;
2015         --linux | --with-linux)
2016             if ! LINUX=$(canon_path "$2"); then
2017                 fatal 1 "Could not determine the canonical location of $2"
2018             fi
2019             shift 2
2020             ;;
2021         --distro)
2022             DISTRO=$2
2023             shift 2
2024             ;;
2025         --reusebuild)
2026             if ! REUSEBUILD=$(canon_path "$2"); then
2027                 fatal 1 "Could not determine the canonical location of $2"
2028             fi
2029             shift 2
2030             ;;
2031         --norpm)
2032             NORPM=true
2033             shift
2034             ;;
2035         --noiokit)
2036             IOKITRPM=false
2037             shift
2038             ;;
2039         --patchless)
2040             PATCHLESS=true
2041             shift
2042             ;;
2043         --kernelrpm)
2044             if ! KERNELRPMSBASE=$(canon_path "$2"); then
2045                 fatal 1 "Could not determine the canonical location of $2"
2046             fi
2047             shift 2
2048             ;;
2049         --timestamp)
2050             TIMESTAMP=$2
2051             shift 2
2052             ;;
2053         --lustre)
2054             if ! LUSTRE=$(canon_filepath "$2"); then
2055                 fatal 1 "Could not determine the canonical location of $2"
2056             fi
2057             shift 2
2058             ;;
2059         --nodownload)
2060             DOWNLOAD=false
2061             shift 1
2062             ;;
2063         --nosrc)
2064             DO_SRC=false
2065             shift 1
2066             ;;
2067         --ofed-version)
2068             OFED_VERSION="$2"
2069             shift 2
2070             ;;
2071         --mpss-version)
2072             MPSS_VERSION="$2"
2073             shift 2
2074             ;;
2075         --publish)
2076             shift
2077             ;;
2078         --disable-zfs)
2079             WITH_ZFS="no"
2080             shift
2081             ;;
2082         --release)
2083             RELEASE=true
2084             shift
2085             ;;
2086         --src)
2087             DO_SRC=true
2088             shift 1
2089             ;;
2090         --stage)
2091             STAGEDIR=$2
2092             shift 2
2093             ;;
2094         --target)
2095             TARGET=$2
2096             shift 2
2097             ;;
2098         --target-archs)
2099             TARGET_ARCHS=$2
2100             shift 2
2101             ;;
2102         --xen)
2103             XEN=true
2104             shift
2105             ;;
2106         --set-value)
2107             eval $2
2108             shift 2
2109             ;;
2110         --)
2111             shift
2112             # there are actually some lustre configure flags that we need to
2113             # handle ourselves (but we still give them to configure)
2114             if [[ \ $@\  == *\ --disable-tests\ * ]]; then
2115                 LUSTRE_TESTS=false
2116             fi
2117             CONFIGURE_FLAGS=$@
2118             break
2119             ;;
2120         *)
2121             usage 1 "Unrecognized option: $1"
2122             ;;
2123     esac
2124 done
2125
2126 check_options
2127
2128 unpack_lustre
2129
2130 # XXX - should we _always_ get the buildid from the META file?  what are the
2131 # other (i.e. non-lustre-tarball use cases of lbuild)?
2132 BUILDID=$(sed -n -e 's/^BUILDID = //p' lustre/META)
2133
2134 load_target
2135
2136 if [ -n "$OFED_VERSION" -a "$OFED_VERSION" != "inkernel" ]; then
2137     download_ofed
2138     unpack_ofed || fatal 1 "Error unpacking OFED tarball"
2139 fi
2140
2141 if [ -n "$MPSS_VERSION" ]; then
2142     [ -z "$MPSS_DISTRO" ] && MPSS_DISTRO=$(autodetect_distro)
2143
2144     MPSS_INFO=$(mktemp -u mpss-info-XXXXXXXXXX.html)
2145     download_mpss_info "$MPSS_INFO"
2146
2147     if [ "$MPSS_VERSION" = "last" ]; then
2148         MPSS_VERSION=$(parse_mpss_info "$MPSS_INFO" "" ${MPSS_DISTRO})
2149         [ -z "$MPSS_VERSION" ] &&
2150             fatal 1 "Could not determine the last MPSS version"
2151     fi
2152
2153     MPSS_MAJ=${MPSS_VERSION%%.*}
2154     MPSS_VER=${MPSS_VERSION%%-*}
2155     MPSS_BLD=${MPSS_VERSION##*-}
2156     [ "$MPSS_VER" = "$MPSS_BLD" ] && MPSS_BLD=0
2157
2158     download_mpss "$MPSS_INFO"
2159     [ -r "$MPSS_INFO" ] && rm -f "$MPSS_INFO"
2160     echo "Building with MPSS $MPSS_VER-$MPSS_BLD"
2161     unpack_mpss  || fatal 1 "Error unpacking MPSS tarballs"
2162     prepare_mpss || fatal 1 "Error preparing MPSS for kernel modules build"
2163
2164     if [ -z "$MPSS_OFED" ]; then
2165         MPSS_OFED=$(find $PWD -type f -path "*/ofed-driver*/Module.symvers" -print -quit)
2166         if [ -n "$MPSS_OFED" ]; then
2167             MPSS_OFED="--with-o2ib=$(dirname $MPSS_OFED)"
2168         else
2169             MPSS_OFED="--without-o2ib"
2170         fi
2171     fi
2172
2173     # disable unsupported parts:
2174     PATCHLESS=true
2175     IOKITRPM=false
2176     LDISKFSRPM=false
2177     WITH_ZFS="no"
2178
2179     # define variables for cross compilation:
2180     CROSS_SUFFIX="-mic"
2181     if [ "$MPSS_MAJ" = "3" ]; then
2182         CC_TARGET_ARCH=k1om-mpss-linux
2183         LINUX="$TOPDIR/mpss"
2184         RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"cross_requires /bin/sh\""
2185     else
2186         CC_TARGET_ARCH=x86_64-k1om-linux
2187         LINUX="$TOPDIR/mpss/card/kernel"
2188         RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"cross_requires intel-mic-gpl = $MPSS_VER\""
2189     fi
2190     LUSTRE_VERSION=$(sed -n -e 's/^VERSION = //p' lustre/META)
2191     CONFIGURE_FLAGS="$CONFIGURE_FLAGS $MPSS_OFED --host=$CC_TARGET_ARCH --build=x86_64-pc-linux"
2192     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"post_script build/gen_filelist.sh\""
2193     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"make_args ARCH=k1om CROSS_COMPILE=${CC_TARGET_ARCH}-\""
2194     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"cross_path ${CROSS_PATH:=/opt/lustre/${LUSTRE_VERSION}/${CC_TARGET_ARCH}}\""
2195     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"rootdir %{cross_path}\""
2196     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_prefix %{cross_path}/usr\""
2197     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_mandir %{_prefix}/share/man\""
2198     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"_sysconfdir %{cross_path}/etc\""
2199     RPMBUILD_DEFS="$RPMBUILD_DEFS --define \"kmoddir extra\""
2200
2201     # redefine CC for proper ./configure during rpmbuild
2202     export CC=${CC_TARGET_ARCH}-gcc
2203 fi
2204
2205 # make sure the RPM build environment is set up
2206 create_rpmbuild_dirs
2207
2208 # if an unpacked kernel source tree was given on the command line
2209 # just build lustre with it (nothing distro kernel specific here)
2210 if [ -n "$LINUX" ]; then
2211     find_linux_release() {
2212         _find_linux_release $LINUX
2213     }
2214     build_ofed "${LINUXOBJ:-$LINUX}" "$OFED_VERSION" ||
2215         fatal 1 "error building OFED"
2216     build_lustre "$LINUX" "$LINUXOBJ"
2217 else
2218     if [ ! -f "${LBUILD_DIR}/lbuild-$DISTROMAJ" ]; then
2219         fatal 1 "${LBUILD_DIR}/lbuild-$DISTROMAJ not found"
2220     fi
2221     source ${LBUILD_DIR}/lbuild-$DISTROMAJ
2222     build_with_srpm || fatal 1 "Failed to build_with_srpm"
2223 fi
2224
2225 stage